#!/usr/bin/env python
# Copyright (C) 2013, Xcoo, Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# -*- coding: utf-8 -*-

try:
    from hashlib import md5
except ImportError:
    from md5 import md5


class Reader(object):

    def __init__(self, input_path, output_path):
        self._buf = ""
        self._input_path = input_path
        self._output_path = output_path
        self._inport(self._input_path)

    def _save(self, output):
        fp = open(self._output_path, "w")
        fp.write(output)
        fp.close()

    def _inport(self, input_path):
        fp = open(self._input_path, "r")
        self._buf = fp.read()
        fp.close()
        self._buf = unicode(self._buf, 'utf-8')

    def get_buf(self):
        return self._buf

    def export_to_xml(self, output):
        f = open(self._output_path, "w")
        f.write(output)
        f.close()
